package bitel.billing.test.convert;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import javax.sql.DataSource;

import org.apache.commons.dbcp.ConnectionFactory;
import org.apache.commons.dbcp.DriverManagerConnectionFactory;
import org.apache.commons.dbcp.PoolableConnectionFactory;
import org.apache.commons.dbcp.PoolingDataSource;
import org.apache.commons.pool.impl.GenericObjectPool;

import bitel.billing.common.CommonTimeUtils;
import bitel.billing.server.contract.bean.Contract;
import bitel.billing.server.contract.bean.ContractManager;
import bitel.billing.server.script.bean.event.EventProcessor;
import bitel.billing.server.util.SetupData;
import bitel.billing.server.util.TimeUtils;
import bitel.billing.server.util.Utils;

public class Odincovo
{
	private static int PID_FIO = 1;
	private static int PID_PHONE = 3;
	//private static int PID_PRIM = 28;
	private static int PID_DOC_SER = 6;
	private static int PID_DOC_NUM = 7;
	private static int PID_DOC_GIVEN_BY = 8;
	private static int PID_DOC_GIVEN_ON = 9;
	private static int PID_DOC_ADRESS = 11;
	private static int PID_DOC_BITH_DATE = 10;
	private static int PID_CONTRACT_STATUS = 12;
	private static int PID_ADRESS = 2;
	
	
	
	static private DataSource getDataSource( String dbURL, String dbUser, String dbPswd )
	{
		DataSource dataSource = null;
		
		String driver = "com.mysql.jdbc.Driver";
		
		int minIdle = 20;
		int maxIdle = 50;
		int maxActive = 300; 

		boolean testOnBorrow = true;
		boolean testOnReturn = true;

		try
		{
			Class.forName( driver ).newInstance();

			ConnectionFactory connectionFactory =
				new DriverManagerConnectionFactory( dbURL, dbUser, dbPswd );

			GenericObjectPool connectionPool = new GenericObjectPool( null );

			connectionPool.setMinIdle( minIdle );
			connectionPool.setMaxIdle( maxIdle );
			connectionPool.setMaxActive( maxActive );
			connectionPool.setTestOnBorrow( testOnBorrow );
			connectionPool.setTestOnReturn( testOnReturn );

			new PoolableConnectionFactory( connectionFactory, connectionPool,
										   null, "SELECT 1", false, true );

			dataSource = new PoolingDataSource( connectionPool );
			
			/*//Connection con;
			Connection con = DriverManager.getConnection(connectionUrl);*/
			
		}
		catch ( Exception ex )
		{
			ex.printStackTrace();
		}
		
		return dataSource; 
	}	
	
	
	public static Map<Integer, Map > getUsers ( ResultSet rs )
	{
		Map<Integer, Map> result = new TreeMap<Integer, Map>();
		try
		{
			
			while (rs.next())
			{
				Map<String, Object> line = new HashMap<String, Object>();
				int uid = rs.getInt( "uid" );
				
				int gid = rs.getInt( "gid" );
				line.put( "gid", gid );
				
				
				String user = rs.getString( "user" );
				line.put( "user", user );
				
				String password  = rs.getString( "password" );
				line.put( "password", password );
				
				double deposit = rs.getDouble(  "deposit" );
				line.put( "deposit", deposit );
				
				double credit = rs.getDouble(  "credit" );
				line.put( "credit", credit );
				
				String fio = rs.getString( "fio" );
				line.put( "fio", fio );
				
				String phone = rs.getString( "phone" );
				line.put( "phone", phone );
				
				
				String prim = rs.getString( "prim" );
				line.put( "prim", prim );
				
				Date add_date = rs.getDate( "add_date" );
				/*if (add_date == null)
				{
					System.out.println("contract  " + uid + ": date is null"  );
					add_date = new Date();
					
				}
				*/
				line.put( "add_date", add_date );
				
				boolean blocked = rs.getBoolean( "blocked" );
				line.put( "blocked", blocked );
				
				
				/*
				boolean activated = rs.getBoolean( "activated" );
				line.put( "activated", activated );
				
				
				Date last_connection =  rs.getTimestamp( "last_connection" );
				line.put( "last_connection", last_connection );
				
				
				String framed_ip = rs.getString( "framed_ip" );
				line.put( "framed_ip", framed_ip );
				
				
				String mac = rs.getString("mac");
				line.put( "mac", mac );
				*/
				
				boolean juridical_person = "yes".equals( rs.getString( "juridical_person" ) );
				line.put( "juridical_person", juridical_person );
				
				boolean physical_disconnect  = "yes".equals( rs.getString( "physical_disconnect" ) );
				line.put( "physical_disconnect", physical_disconnect );
				
				String vv_agr_number = rs.getString( "vv_agr_number" );
				line.put( "vv_agr_number", vv_agr_number );
				
				Date vv_agr_date = rs.getDate( "vv_agr_date" );
				line.put( "vv_agr_date", vv_agr_date );				
				
				String vv_doc_ser = rs.getString( "vv_doc_ser" );
				line.put( "vv_doc_ser", vv_doc_ser );
				
				String vv_doc_num = rs.getString( "vv_doc_num" );
				line.put( "vv_doc_num", vv_doc_num );
				
				String vv_doc_given_by = rs.getString( "vv_doc_given_by" );
				line.put( "vv_doc_given_by", vv_doc_given_by );
				
				Date vv_doc_given_on = rs.getDate ( "vv_doc_given_on" );
				line.put( "vv_doc_given_on", vv_doc_given_on );
				
				String vv_doc_addr = rs.getString( "vv_doc_addr" );
				line.put( "vv_doc_addr", vv_doc_addr );
				
				double credit_trust = rs.getDouble(  "credit_trust" );
				line.put( "credit_trust", credit_trust );
				
				String local_ip = rs.getString( "local_ip" );
				line.put( "local_ip", local_ip );
				
				boolean agr_status = "yes".equals( rs.getString( "agr_status" ) );
				line.put( "agr_status", agr_status );
				
				boolean editable_in_interface = "yes".equals( rs.getString( "editable_in_interface" ) );
				line.put( "editable_in_interface", editable_in_interface );
				
				Date birth_date = rs.getDate( "birth_date" );
				line.put( "birth_date", birth_date );
				
				result.put( uid, line );
				
			}
		} catch (SQLException e)
		{ 
			e.printStackTrace();
		}
		
		return result; 
	}
	

	public static Map<Integer, Map > getAddresses ( ResultSet rs )
	{
		Map<Integer, Map> result = new HashMap<Integer, Map>();
		try
		{
			
			while (rs.next())
			{
				Map<String, Object> line = new HashMap<String, Object>();
				int uid = rs.getInt( "uid" );
				
				
				String city = rs.getString( "city" );
				line.put( "city", city );
				
				String street  = rs.getString( "street" );
				line.put( "street", street );
				
				String house = rs.getString(  "house" );
				line.put( "house", house );
				
				String building = rs.getString(  "building" );
				line.put( "building", building );
				

				String entrance = rs.getString(  "entrance" );
				line.put( "entrance", entrance );

				String level = rs.getString(  "level" );
				line.put( "level", level );

				String flat = rs.getString(  "flat" );
				line.put( "flat", flat );
				
				
				result.put( uid, line );
				
			}
		} catch (SQLException e)
		{ 
			e.printStackTrace();
		}
		
		return result; 
	}
	
	public static Map<Integer, String > getTarifs ( DataSource dataSource )
	{
		
		Map<Integer, String> result = new HashMap<Integer, String>();
		try
		{
			String query = " Select * from packets";
			Connection con =  dataSource.getConnection();
			 
			ResultSet rs =  con.createStatement().executeQuery( query );
			
			while (rs.next())
			{
				
				int uid = rs.getInt( "gid" );				
				String packet = rs.getString( "packet" );				
				result.put( uid, packet );
				
			}
		} catch (Exception e)
		{ 
			e.printStackTrace();
		}
		
		return result; 
	}	
	
	
	
	private static boolean readBoolean(Map line, String name)
	{
		Boolean result = (Boolean) line.get( name );
		return result == null ? false :  result;
	}
	
	private static Date readDate(Map line, String name)
	{
		Date result = (Date) line.get( name );
		return result;
	}
	
	private static String readString(Map line, String name)
	{
		String result = (String) line.get( name );
		return result;
	}
	
	private static int readInt(Map line, String name, int defaultValue)
	{
		int result = line.get( name ) != null ? ( Integer ) line.get( name ) : defaultValue;  
		return result;
	}	
	
	private static double readDouble(Map line, String name)
	{
		double result = (Double) line.get( name );
		return result;
	}	
		
	private static List<Contract> createContacts(	int gr,
													SetupData setup,
													Map<Integer, Map> users,
													Map<Integer, String > tarifs,
													int jurPatterId,
													int physPatternId,
													int dialupMID)
	{
		
		List<Contract> result = new ArrayList<Contract>();
		Connection con = null;
		Date currDate = new Date();
		try
		{
			con = setup.getDBConnectionFromPool();
			
			
			
			System.out.println( users.size() + " contacts was found..");
			System.out.println( " importing contracts..");
			Map<String, Integer > billingTarifMap = ConvertUtil.getBillingTariffMap( setup );
			for (Map.Entry<Integer, Map> entry : users.entrySet())
        	{
        		int uid = entry.getKey();
        		Map line = entry.getValue();
        		
        		boolean isJur =  readBoolean( line, "juridical_person" ); 
        		
        		int patternId =  isJur ? jurPatterId : physPatternId;
        		Date date = readDate( line, "vv_agr_date" );
        		if (date == null || date.getTime() == 0)
        		{        			
        			date = new Date();
        		}
        		
        		String passwd = readString( line, "password" );
        		
        		ContractManager manager =  new ContractManager( con );
        		
        		
        		String title = readString( line, "vv_agr_number" );
        		if ( Utils.isEmptyString( title ) )
        		{
        			title = null;			
        		}
        		
        		
        		Contract contract = manager.createFromPattern( patternId, title, CommonTimeUtils.convertDateToCalendar( date ), passwd );
        		
        		if (contract != null)
        		{	
        			int cid = contract.getID();
        			
        			result.add( contract );
        			updateContactInfo( gr, contract.getID(), setup, line);
        			
        			updateContactParams(contract, con, cid, line);
        			
        			updateContactAdress(contract, con, cid, line);
        			
        			updateContactBalance(contract, con, cid, line, currDate);
        			updateDiaulupLogins(contract, con, uid, cid,  line, dialupMID);
        			updateTarifs( cid, setup, tarifs, line, con, billingTarifMap );
        		}
        		
        		
        		        		
        	}			
			
			System.out.println( result.size() + " contacts was added..");
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			setup.returnConToPool( con );
		}		
		
		return result;
	}
	
	private static void updateDiaulupLogins(	Contract contract,
	                                        	Connection con,
	                                        	int uid,
												int cid,
												Map line,
												int moduleId)
	{		
		
		
		try
		{
            
			int login = uid;
			
			String query = "INSERT INTO user_login_" + moduleId + " ( cid, login, date1, date2, " +
            "status, session, comment, object_id, pswd ) VALUES ( ?, ?, NULL, NULL, ?, ?, ?, ?, ? )";
		    PreparedStatement ps =  con.prepareStatement(   query );
		    int idx = 1;
		    ps.setInt( idx++, cid );
		    ps.setInt( idx++, login );
		    ps.setBoolean( idx++, readBoolean( line, "blocked" ) );
		    ps.setInt( idx++, 0 );
		    ps.setString( idx++, readString( line, "prim" ) );
		    ps.setInt( idx++, 0 );
		    ps.setString( idx++, readString( line, "password" ) );		    
		    ps.executeUpdate();
		    
		    int lid = lastInsertId( con );
		    
		    query = "DELETE FROM user_alias_" + moduleId + " WHERE login_id=?";
		    ps =  con.prepareStatement(   query );
	        ps.setInt( 1, lid );
	        ps.executeUpdate();
	    
	        query = "INSERT INTO user_alias_" + moduleId + " VALUES ( ?, ? )";
	        ps =  con.prepareStatement(   query );
	        ps.setInt( 1, lid );
	        ps.setString( 2, readString( line, "user" ) );
	        ps.executeUpdate();
	        
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{						
		}			
		
	}


	private static void updateContactBalance(	Contract contract,
	                                         	Connection con,
												int cid,												
												Map line,
												Date currDate)
	{
		
		Calendar cal = new GregorianCalendar();
		cal.setTime( currDate );
		
		int year = cal.get( Calendar.YEAR );
		int month = cal.get( Calendar.MONTH  ) + 1;
		try
		{			
			String query = "INSERT INTO contract_balance(yy, mm, cid, summa1, summa2, summa3, summa4) VALUES(?, ?, ?, ?, 0, 0, 0)";
			PreparedStatement ps =  con.prepareStatement( query );
			int idx = 1;
			ps.setInt( idx++, year );
			ps.setInt( idx++, month );
			ps.setInt( idx++, cid );
			ps.setDouble( idx++, readDouble( line, "deposit" ) );
			
			ps.executeUpdate();
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
		}		
		
	}


	private static void updateContactAdress(	Contract contract,
	                                        	Connection con,
												int cid,
												Map line)
	{ 
		
		
		if (readBoolean( line, "noAddress" ))
		{
			return;
		}
		
		String city = readString( line, "city" );
		String street = readString( line, "street" );
		String house = readString( line, "house" );
		String building = readString( line, "building" );
		String entrance = readString( line, "entrance" );
		String level = readString( line, "level" );
		String flat = readString( line, "flat" );
		
		
		
		 
		
		StringBuffer address = new StringBuffer();
		address.append( city + ", ");
		address.append( street + ", ");
		address.append( house + ", ");
		address.append( building + ", ");
		address.append( entrance + ", ");
		address.append( level + ", ");
		address.append( flat );
		
		
		
		try
		{
			String query = "INSERT INTO contract_parameter_type_2 " +
			"( cid, pid, hid, flat,  pod, floor, address, comment, room) " +
			"VALUES ( ?, ?, NULL, ?, ?, ?, ?, ?, ? )";
			
			PreparedStatement ps = con.prepareStatement( query );
			int idx = 1;
			ps.setInt( idx++, cid );
			ps.setInt( idx++, PID_ADRESS );			
			ps.setString( idx++, flat );
			
			ps.setInt( idx++, Utils.parseIntString( entrance, -1 ) );
			ps.setInt( idx++, Utils.parseIntString( level, -1 ) );
			ps.setString( idx++, address.toString() );
			ps.setString( idx++, "" );
			ps.setString( idx++, "" );
			
			
			ps.executeUpdate();			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
		}				
		
	}


	private static void updateContactParams(	Contract contract,
												Connection con,
												int cid,
												Map line)
	{
		
		
		addContactParamString(contract, con, cid, readString( line, "fio" ), PID_FIO);
		addContactParamString(contract, con, cid, readString( line, "phone" ), PID_PHONE);
		//addContactParamString(contract, setup, cid, readString( line, "prim" ), PID_PRIM);
		addContactParamString(contract, con, cid, readString( line, "vv_doc_ser" ), PID_DOC_SER);
		addContactParamString(contract, con, cid, readString( line, "vv_doc_num" ), PID_DOC_NUM);
		addContactParamString(contract, con, cid, readString( line, "vv_doc_given_by" ), PID_DOC_GIVEN_BY);			
		addContactParamString(contract, con, cid, readString( line, "vv_doc_addr" ), PID_DOC_ADRESS);
		
		addContactParamDate(contract, con, cid, readDate( line, "vv_doc_given_on" ), PID_DOC_GIVEN_ON);
		addContactParamDate(contract, con, cid, readDate( line, "birth_date" ), PID_DOC_BITH_DATE);
		
		addContactParamFlag(contract, con, cid, readBoolean( line, "agr_status" ), PID_CONTRACT_STATUS);
		
	}


	private static void addContactParamFlag(	Contract contract,
	                                        	Connection con,
												int cid,
												boolean value,
												int pid )
	{		
		try
		{
			String query = "DELETE FROM contract_parameter_type_5 WHERE cid=? AND pid=?";
			PreparedStatement ps =  con.prepareStatement( query );
			ps.setInt( 1, cid );
			ps.setInt( 2, pid );
			ps.executeUpdate();

			
			query = "INSERT INTO contract_parameter_type_5 " +
					"( cid, pid, val ) VALUES ( ?, ?, ? )";
			ps = con.prepareStatement( query );
			ps.setInt( 1, cid );
			ps.setInt( 2, pid );
			ps.setBoolean( 3, value );
			ps.executeUpdate();
		
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			
		}				
		
	}


	private static void addContactParamDate(	Contract contract,
	                                        	Connection con,
												int cid,
												Date value,
												int pid )
	{		
		try
		{			
			String query = "DELETE FROM contract_parameter_type_6 WHERE cid=? AND pid=?";
			PreparedStatement ps =  con.prepareStatement( query );
			ps.setInt( 1, cid );
			ps.setInt( 2, pid );
			ps.executeUpdate();

			if( value != null )
			{
				query = "INSERT INTO contract_parameter_type_6 " +
						"( cid, pid, val ) VALUES ( ?, ?, ? )";
				ps = con.prepareStatement( query );
				ps.setInt( 1, cid );
				ps.setInt( 2, pid );
				ps.setDate( 3, TimeUtils.convertDateToSQL( value ) );
				ps.executeUpdate();
			}

			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
		}		
						
		
	}
	
	private static int lastInsertId(Connection con) throws SQLException
    {
        int id = -1;
		String query = "SELECT last_insert_id() as id";
		PreparedStatement ps =  con.prepareStatement( query );
        
        ResultSet rs = ps.executeQuery();
        while( rs.next() )
            id = rs.getInt( 1 );
        rs.close();
        return id;
    }

	private static void addContactParamString( Contract contract, Connection con, int cid, String value, int pid )
	{
		
		try
		{
			
			String query = "DELETE FROM contract_parameter_type_1 WHERE cid=? AND pid=?";
			PreparedStatement ps =  con.prepareStatement( query );
			ps.setInt( 1, cid );
			ps.setInt( 2, pid );
			ps.executeUpdate();

			if ( !Utils.isEmptyString( value ) )
			{
				query = "INSERT INTO contract_parameter_type_1 " +
						"( cid, pid, val ) VALUES ( ?, ?, ? )";
				ps = con.prepareStatement( query );
				ps.setInt( 1, cid );
				ps.setInt( 2, pid );
				ps.setString( 3, value );
				ps.executeUpdate();
			}			
			
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
		}		
				
		
	}


	private static void updateContactInfo(	int gr,
											int cid,
											SetupData setup,
											Map line)
	{
		
		Connection con = null;
		
		try
		{
			con = setup.getDBConnectionFromPool();
			String query = "UPDATE contract SET gr=gr| ?,   " +
					" closeSumma = ?," +
					" comment = ?" +					
					" WHERE id=?";
			PreparedStatement ps = con.prepareStatement( query );
			int idx =1;
			ps.setInt( idx++, gr );
			ps.setDouble ( idx++, readDouble( line, "credit" ) );							
			ps.setString( idx++, readString( line, "fio" ) );			
			ps.setInt( idx++, cid );

			ps.executeUpdate();
			
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			closeConnection( con );
		}
			
	}
	
	private static void updateTarifs(	int cid,										
										SetupData setup,
										Map<Integer, String > tarifs,
										Map line,
										Connection con,
										Map<String, Integer > billingTarifMap)
	{
		
		try
		{

            con = setup.getDBConnectionFromPool();
			
			String query = "INSERT INTO contract_tariff( cid, tpid) VALUES ( ?, ?)";
		    PreparedStatement ps =  con.prepareStatement(   query );
		    
		    ps.setInt( 1, cid );
		    
		    
		    int gid = readInt( line, "gid", -1 );
		    if (gid < 0 )
		    {
		    	return;
		    }
		    
		    String tarifName = tarifs.get( gid );
		    if (tarifName == null)
		    {
		    	throw new RuntimeException("tarif was not found for user gid=" + gid );
		    }
		    
		    
		    Integer tpid = billingTarifMap.get( tarifName );
	    	if ( tpid != null)
	    	{
	    		ps.setInt( 2, tpid );
	    		ps.executeUpdate();
	    	}
	    	else
	    	{
	    		throw new RuntimeException("tarif '" + tarifName + "' was not found in bgbilling!!"  );	
	    	}
	    	
	    	
	    
	        
			
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{			
			setup.returnConToPool( con );
		}				
	}
	
	
	public static void main( String[] args )
	{
		try
		{
			SetupData setup = new SetupData("data.data");
			
			EventProcessor.initProcessor( setup, false );
			
			if (args.length < 1)
			{
				System.out.println( "Odincovo db_name" );
				System.exit( 1 );				
			}
			
			String db = args[0];
			String sourceURL = "jdbc:mysql://127.0.0.1:3306/" + db +"?useUnicode=true&characterEncoding=Cp1251&allowUrlInLocalInfile=true&zeroDateTimeBehavior=convertToNull&jd";
			String sourceUser = "root";
			String sourcePswd = "";
			
			
			int group  = 1;
			int jurPatterId = 1; 
			int physPatternId = 2;
			
			int dialupMID = 1;
			
			DataSource dataSource = getDataSource( sourceURL, sourceUser, sourcePswd );
			
			ConvertUtil.removeContracts( group, setup ); 		
			
			
	        
			
			
	        
	        Map<Integer, Map > users = read( dataSource, true );                
	        Map<Integer, Map > adresses = read( dataSource, false );
	        
	        Map<Integer, String > tarifs = getTarifs( dataSource );
	        
	        for (Integer uid  : users.keySet())
	        {
	        	Map<String, Object> userValues  =  users.get(  uid );
	        	Map<String, Object> adressValues  =  adresses.get(  uid );
	        	
	        	
	        	if (adressValues != null)
	        	{
		        	for (Map.Entry<String, Object> entry : adressValues.entrySet())
		        	{
		        		userValues.put( entry.getKey(), entry.getValue() );	
		        	}
	        	}
	        	else
	        	{
	        		userValues.put( "noAddress", true ); 
	        	}
	        	
	        	
	        	
	        	
	        }
	        
	        createContacts(group, setup, users, tarifs, jurPatterId, physPatternId, dialupMID);
	        
	        
		}
		catch( Exception ex)
		{
			ex.printStackTrace();
		}

	}


	private static Map<Integer, Map > read( DataSource dataSource,  boolean isUsers )
	{
		Connection con = null;
		
        try
        {
        	con = dataSource.getConnection();        	
        	 
        	
        	if (isUsers)
        	{	
        		String query = " Select * from users";    		
        		return getUsers( con.createStatement().executeQuery( query ) );
        	}
        	else
        	{
        		String query = " Select * from addresses";
        		return getAddresses( con.createStatement().executeQuery( query ) ); 
        	}
        	
        	 
        }
        catch (Exception ex)
        {
        	ex.printStackTrace();
        }
        finally
        {
        	closeConnection( con );
        }
		return null;
	}


	

	private static void closeConnection( Connection con )
	{
		try
		{
			con.close();
		} catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	

}
